﻿using System;
using System.Windows.Forms;
using CommandTagLauncher;

namespace CommandTagLauncherApp
{
	static class Program
	{
		/// <summary>
		/// アプリケーションのメイン エントリ ポイントです。
		/// </summary>
		[STAThread]
		static void Main( string[] args )
		{
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault( false );

			if ( IsMultipleExecutionMode( args ) )
			{
				Run();
			}
			else
			{
				RunAsSingleExecutionMode();
			}
		}

		private static void RunAsSingleExecutionMode()
		{
			System.Threading.Mutex mutex = new System.Threading.Mutex( false, Application.ProductName );

			if ( mutex.WaitOne( 0, false ) )
			{
				Run();
			}

			GC.KeepAlive( mutex );

			mutex.Close();
		}

		private static void Run()
		{
			Application.Run( new FormMain() );
		}

		private static bool IsMultipleExecutionMode( string[] args )
		{
			if ( args.Length == 0 )
			{
				return false;
			}

			return args[0] == "-m";
		}
	}
}
