﻿using System.Drawing;
using System.Windows.Forms;

namespace CommandTagLauncher
{
	public partial class InputArgumentsForm : Form
	{
		public InputArgumentsForm()
		{
			InitializeComponent();
		}

		public void SetCommand( Command command )
		{
			labeledComboBoxArguments.TitleText = command.Name;

			SetUpLabeledComboBoxArguments( command );
		}

		private void SetUpLabeledComboBoxArguments( Command command )
		{
			labeledComboBoxArguments.ComboBox.BeginUpdate();

			labeledComboBoxArguments.ComboBox.Items.Clear();
			labeledComboBoxArguments.ComboBox.Items.AddRange( command.ArgumentsHistory.ToArray() );

			if ( 1 <= labeledComboBoxArguments.ComboBox.Items.Count )
			{
				labeledComboBoxArguments.ComboBox.SelectedIndex = 0;
			}
			else
			{
				labeledComboBoxArguments.ComboBox.Text = string.Empty;
			}

			labeledComboBoxArguments.ComboBox.EndUpdate();
		}

		public void SetView( Font font, Color backColor, Color foreColor )
		{
			labeledComboBoxArguments.TitleFont = font;
			labeledComboBoxArguments.ComboBox.Font = font;
			labeledComboBoxArguments.ComboBox.ForeColor = foreColor;
			labeledComboBoxArguments.ComboBox.BackColor = backColor;

			Height = font.Height * 2 + 60;
		}

		public string Arguments
		{
			get { return labeledComboBoxArguments.ComboBox.Text; }
		}

		private void labeledComboBoxArguments_ComboBox_KeyDown( object sender, KeyEventArgs e )
		{
			switch ( e.KeyData )
			{
				case Keys.Enter:
					DialogResult = DialogResult.OK;
					break;

				case Keys.Escape:
					labeledComboBoxArguments.ComboBox.Text = string.Empty;
					break;

				case Keys.Control | Keys.A:
					labeledComboBoxArguments.ComboBox.SelectAll();
					break;
			}
		}
	}
}
