﻿using System;

namespace CommandTagLauncher
{
	public sealed class GroupCommand : Command
	{
		private readonly ChildCommandCollection items = new ChildCommandCollection();

		public ChildCommandCollection Items
		{
			get { return items; }
		}

		protected override void DoExecute( string arguments )
		{
			foreach ( Command command in items )
			{
				ExecuteChildCommand( command );
			}
		}

		private void ExecuteChildCommand( Command command )
		{
			DateTime lastExecutedTimeBackup = command.LastExecutedTime;

			command.Execute( command.DefaultArguments );

			command.LastExecutedTime = lastExecutedTimeBackup;
		}
	}
}
