﻿using System.Windows.Forms;

namespace CommandTagLauncher
{
	public class CommonOptions
	{
		private bool initialSearch = true;

		public bool InitialSearch
		{
			get { return initialSearch; }
			set { initialSearch = value; }
		}

		private bool romajiMatching;

		public bool RomajiMatching
		{
			get { return romajiMatching; }
			set { romajiMatching = value; }
		}

		private bool hideWhenLoaded;

		public bool HideWhenLoaded
		{
			get { return hideWhenLoaded; }
			set { hideWhenLoaded = value; }
		}

		private bool topMost;

		public bool TopMost
		{
			get { return topMost; }
			set { topMost = value; }
		}

		private int commandsArgumentsHistoryMaxCount = Command.DefaultArgumentsHistoryMaxCount;

		public int CommandsArgumentsHistoryMaxCount
		{
			get { return commandsArgumentsHistoryMaxCount; }
			set { commandsArgumentsHistoryMaxCount = value; }
		}

		private int maxShowItemsCount = 50;

		public int MaxShowItemsCount
		{
			get { return maxShowItemsCount; }
			set { maxShowItemsCount = value; }
		}

		#region Several Keys

		private Keys captureCurrentProgramKey = Keys.Pause;

		public Keys CaptureCurrentProgramKey
		{
			get { return captureCurrentProgramKey; }
			set { captureCurrentProgramKey = value; }
		}

		private Keys toggleMainWindowVisibleKey = Keys.Alt | Keys.X;

		public Keys ToggleMainWindowVisibleKey
		{
			get { return toggleMainWindowVisibleKey; }
			set { toggleMainWindowVisibleKey = value; }
		}

		private Keys executeKey = Keys.Enter;

		public Keys ExecuteKey
		{
			get { return executeKey; }
			set { executeKey = value; }
		}

		private Keys executeWithInputArgumentsKey = Keys.Shift | Keys.Enter;

		public Keys ExecuteWithInputArgumentsKey
		{
			get { return executeWithInputArgumentsKey; }
			set { executeWithInputArgumentsKey = value; }
		}

		private Keys executeWithMostRecentUsedArgumentsKey = Keys.Control | Keys.Shift | Keys.Enter;

		public Keys ExecuteWithMostRecentUsedArgumentsKey
		{
			get { return executeWithMostRecentUsedArgumentsKey; }
			set { executeWithMostRecentUsedArgumentsKey = value; }
		}

		#endregion

		private bool confirmWhenRemovingItems = true;

		public bool ConfirmWhenRemovingItems
		{
			get { return confirmWhenRemovingItems; }
			set { confirmWhenRemovingItems = value; }
		}

		private bool confirmWhenClearArgumentsHistory = true;

		public bool ConfirmWhenClearArgumentsHistory
		{
			get { return confirmWhenClearArgumentsHistory; }
			set { confirmWhenClearArgumentsHistory = value; }
		}
	}
}
