﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;
using NUnit.Extensions.Converter;

using Tomham.Collections.Generic;

namespace Tomham.Collections.GenericTest
{
	[TestFixture]
	public class IListUtilityTest : AssertionHelper
	{
		Converter converter = new CollectionConverter( new DefaultConverter() );

		[Test]
		public void MoveUpItems()
		{
			List<string> actual = CreateList();

			object expected = E.a( "bird", "cat", "ant" );

			actual.MoveUpItems<string>( 1, 2 );

			converter.AssertEquals( expected, actual );

			actual.MoveUpItems<string>( 0, 1 );

			converter.AssertEquals( expected, actual );
		}

		private List<string> CreateList()
		{
			List<string> result = new List<string>();

			result.AddRange( new string[] { "ant", "bird", "cat" } );

			return result;
		}

		[Test]
		public void MoveDownItems()
		{
			List<string> actual = CreateList();

			object expected = E.a( "cat", "ant", "bird" );

			actual.MoveDownItems<string>( 0, 1 );

			converter.AssertEquals( expected, actual );

			actual.MoveDownItems<string>( 1, 2 );

			converter.AssertEquals( expected, actual );
		}
	}
}
