﻿using System;
using System.Text;
using System.Windows.Forms;
using NUnit.Extensions.Converter;

// まさーるさんのCollectionConverterをコピペしてベースにさせてもらいました

namespace Tomham.Windows.Forms.Tests
{
	public class ListBoxConverter : SpecificObjectConverter
	{
		public ListBoxConverter( Converter converter )
			: base( converter )
		{
		}

		protected override bool CanConvertSelf( object o )
		{
			return o is ListBox;
		}

		protected override object ConvertSelf( object o )
		{
			ListBox listBox = (ListBox) o;

			StringBuilder buf = new StringBuilder();
			buf.Append( "[" );
			if ( 0 < Context.ExpansionLevel )
			{
				Context.BeginExpansion();
				bool isEmpty = true;

				for ( int index = 0; index < listBox.Items.Count; index++ )
				{
					String str = DelegateToString( listBox.Items[index] );

					str = GetSelectedString( str, index, listBox );
					if ( IsVisible( str ) )
					{
						buf.Append( Environment.NewLine );
						buf.Append( Context.Indent );
						buf.Append( str );
						isEmpty = false;
					}
				}
				if ( isEmpty )
				{
					buf.Append( Environment.NewLine );
					buf.Append( Context.Indent );
					buf.Append( "(empty)" );
				}
				Context.EndExpansion();
				buf.Append( Environment.NewLine );
				buf.Append( Context.Indent );
			}
			else
			{
				bool isEmpty = true;

				for ( int index = 0; index < listBox.Items.Count; index++ )
				{
					String str = DelegateToString( listBox.Items[index] );

					str = GetSelectedString( str, index, listBox );

					if ( IsVisible( str ) )
					{
						if ( !isEmpty )
						{
							buf.Append( ", " );
						}
						else
						{
							isEmpty = false;
						}
						buf.Append( str );
					}
				}
				if ( isEmpty )
				{
					buf.Append( "(empty)" );
				}
			}
			buf.Append( "]" );
			return buf.ToString();
		}

		private string GetSelectedString( string item, int index, ListBox listBox )
		{
			if ( listBox.SelectedIndices.Contains( index ) )
			{
				return "*" + item;
			}
			else
			{
				return item;
			}
		}
	}
}