﻿using System;
using System.Collections.ObjectModel;

namespace Tomham.Windows.Forms.AutoGeneration
{
	public class ControllerCollection : Collection<Controller>
	{
		public void UpdateToTargetAll()
		{
			foreach ( Controller controller in this )
			{
				controller.UpdateToTarget();
			}
		}

		public void UpdateToControlAll()
		{
			foreach ( Controller controller in this )
			{
				controller.UpdateToControl();
			}
		}

		public bool IsValidControllerValuesAll()
		{
			foreach ( Controller controller in this )
			{
				if ( !controller.IsValidControlValues() )
				{
					return false;
				}
			}

			return true;
		}

		public Controller FindController( object target )
		{
			if ( target == null )
			{
				throw new ArgumentNullException( "target" );
			}

			foreach ( Controller controller in this )
			{
				if ( controller.Target == target )
				{
					return controller;
				}
			}

			return null;
		}
	}
}