using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using System.IO;

namespace Tomham.Xml.Serialization
{
	public static class SimpleXmlSerializer
	{
		public static void Serialize( object data, string fileName, Encoding encoding )
		{
			XmlSerializer serializer = new XmlSerializer( data.GetType() );

			using ( TextWriter writer = new StreamWriter( fileName, false, encoding ) )
			{
				serializer.Serialize( writer, data );
			}
		}

		public static T Deserialize<T>( string fileName, Encoding encoding )
		{
			XmlSerializer serializer = new XmlSerializer( typeof( T ) );

			using ( TextReader reader = new StreamReader( fileName, encoding ) )
			{
				return (T)serializer.Deserialize( reader );
			}
		}
	}
}
